SystemOrganization addCategory: #NautilusRefactoring!
SystemOrganization addCategory: #'NautilusRefactoring-Tests'!
SystemOrganization addCategory: #'NautilusRefactoring-Refactorings'!

!NautilusUI methodsFor: '*NautilusRefactoring-menu' stamp: 'BenjaminVanRyseghem 2/14/2012 22:45'!
classRefactoringSubmenu: aBuilder
	<nautilusClassMenu>
	
	(aBuilder item: #'Rename... (r)')
		action: [ self renameClassWithRefactoringEngine: self selectedClass ];
		parent: #'Class Refactoring';
		order: 0.
	
	(aBuilder item: #'Remove... (x)')
		action: [ self removeClassWithRefactoringEngine: self selectedClasses ];
		icon: (self iconClass iconNamed: #removeIcon);
		parent: #'Class Refactoring';
		order: 50.
		
	(aBuilder item: #'Generate Accessors')
		action: [ self refactor generateAccessors ];
		parent: #'Class Refactoring';
		order: 100.
		
	(aBuilder item: #'Generate Superclass...')
		action: [ self refactor generateSuperClass ];
		parent: #'Class Refactoring';
		order: 200.
		
	(aBuilder item: #'Generate Subclass...')
		action: [ self refactor generateSubclass ];
		parent: #'Class Refactoring';
		order: 300.
		
	(aBuilder item: #'Realize')
		action: [ self refactor realizeClass ];
		parent: #'Class Refactoring';
		order: 400.
		
	(aBuilder item: #'Split')
		action: [ self refactor splitClass: self selectedClass ];
		parent: #'Class Refactoring';
		order: 500.
		
	! !

!NautilusUI methodsFor: '*NautilusRefactoring-menu' stamp: 'BenjaminVanRyseghem 1/24/2012 20:46'!
codeRewritingClassSubmenu: aBuilder
	<nautilusClassMenu>
	
	(aBuilder item: #'Rewrite Code')
		action: [ self refactor rewriteCode ];
		parent: #'Code Rewriting';
		order: 0.

	(aBuilder item: #'Search Code')
		action: [ self refactor searchCode ];
		parent: #'Code Rewriting';
		order: 100.
		
	(aBuilder item: #'Type class')
		action: [ self refactor typeClass ];
		parent: #'Code Rewriting';
		order: 200;
		withSeparatorAfter.
		
	(aBuilder item: #'Category Regex')
		action: [ self refactor categoryRegex ];
		parent: #'Code Rewriting';
		order: 300.
		
	(aBuilder item: #'Class Regex')
		action: [ self refactor classRegex ];
		parent: #'Code Rewriting';
		order: 400.
		
	(aBuilder item: #'Protocol Regex')
		action: [ self refactor protocolRegex ];
		parent: #'Code Rewriting';
		order: 500.
		
	(aBuilder item: #'Source Regex')
		action: [ self refactor sourceRegex ];
		parent: #'Code Rewriting';
		order: 600;
		withSeparatorAfter.! !

!NautilusUI methodsFor: '*NautilusRefactoring-class' stamp: 'BenjaminVanRyseghem 2/14/2012 21:09'!
dispatchRemoveClasses: aCollection
	" Override to set the class rename with RB by default "

	^ self removeClassWithRefactoringEngine: aCollection! !

!NautilusUI methodsFor: '*NautilusRefactoring-class' stamp: 'BenjaminVanRyseghem 1/24/2012 19:18'!
dispatchRenameClass: aClass
	" Override to set the class rename with RB by default "

	self renameClassWithRefactoringEngine: aClass! !

!NautilusUI methodsFor: '*NautilusRefactoring-class' stamp: 'BenjaminVanRyseghem 1/24/2012 19:23'!
refactor

	^ NautilusRefactoring model: self! !

!NautilusUI methodsFor: '*NautilusRefactoring-menu' stamp: 'BenjaminVanRyseghem 1/24/2012 20:46'!
refactoringClassMenu: aBuilder
	<nautilusClassMenu>
	
	(aBuilder item: #'Refactoring')
			order: 0;
			withSeparatorAfter.
	
	(aBuilder item: #'Code Rewriting')
			order: 0;
			parent: #'Refactoring'.
			
	(aBuilder item: #'Class Refactoring')
			order: 0;
			parent: #'Refactoring'.! !

!NautilusUI methodsFor: '*NautilusRefactoring-class' stamp: 'BenjaminVanRyseghem 2/14/2012 21:10'!
removeClassWithRefactoringEngine: aCollection

	^ self refactor removeClasses: aCollection ! !

!NautilusUI methodsFor: '*NautilusRefactoring-class' stamp: 'BenjaminVanRyseghem 1/24/2012 19:21'!
renameClassWithRefactoringEngine: aClass

	self refactor renameClass: aClass ! !

RBClassRefactoring subclass: #RBRealizeClassRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusRefactoring-Refactorings'!

!RBRealizeClassRefactoring commentStamp: 'lr 10/19/2007 09:16' prior: 0!
Make a given class concrete, by providing empty templates for all the abstract methods.!

!RBRealizeClassRefactoring methodsFor: 'preconditions' stamp: 'lr 10/26/2009 22:21'!
preconditions
	^ RBCondition
		withBlock: [
			(self theClass withAllSubclasses
				detect: [ :each | 
					(each whichSelectorsReferToSymbol: #subclassResponsibility) notEmpty 
						or: [ (each theMetaClass whichSelectorsReferToSymbol: #subclassResponsibility) notEmpty ] ]
				ifNone: [ nil ]) isNil ]
		errorString: self theClass printString , ' is abstract or has abstract subclasses.'! !

!RBRealizeClassRefactoring methodsFor: 'accessing' stamp: 'lr 10/30/2009 16:27'!
theClass
	^ (self classObjectFor: className) theNonMetaClass! !

!RBRealizeClassRefactoring methodsFor: 'transforming' stamp: 'lr 10/26/2009 22:09'!
transform
	self transform: self theClass.
	self transform: self theClass theMetaClass! !

!RBRealizeClassRefactoring methodsFor: 'transforming' stamp: 'lr 1/21/2010 16:14'!
transform: aClass
	| class method parseTree |
	aClass allSelectors do: [ :selector |
		class := aClass whoDefinesMethod: selector.
		(class notNil and: [ class ~= aClass ]) ifTrue: [
			method := class methodFor: selector.
			(method notNil and: [ method refersToSymbol: #subclassResponsibility ]) ifTrue: [
				parseTree := method parseTree.
				parseTree body 
					temporaries: OrderedCollection new; 
					statements: OrderedCollection new;
					addNode: (RBMessageNode 
						receiver: (RBVariableNode named: 'self')
						selector: #shouldBeImplemented).
				aClass compile: parseTree newSource withAttributesFrom: method ] ] ]! !

!RBCreateAccessorsForVariableRefactoring methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/25/2012 19:38'!
whatToDisplayIn: aBrowser 

	^ (self changes changes select: [:change | {getterMethod. setterMethod} includes: change selector ]) gather: [:change | change whatToDisplayIn: aBrowser ]! !

!RBCompositeRefactoryChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/24/2012 21:22'!
whatToDisplayIn: aBrowser

	^ self changes gather: [:each | each whatToDisplayIn: aBrowser ]! !

!RBAddMethodChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/25/2012 19:52'!
textToDisplay

	^ self source! !

!RBRefactoryChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 2/14/2012 20:11'!
nameToDisplay

	^ self name! !

!RBRefactoryChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/25/2012 19:48'!
textToDisplay

	^ self name! !

!RBRefactoryChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/24/2012 21:29'!
whatToDisplayIn: aChangeBrowser

	^ { self }! !

!RBRenameClassChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 2/14/2012 20:10'!
nameToDisplay

	^ self oldName! !

!RBRenameClassChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/25/2012 20:17'!
textToDisplay

	self printString! !

!RBRenameClassChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/25/2012 20:15'!
whatToDisplayIn: aChangeBrowser

	| result |
	result := OrderedCollection with: self.
	^ result, (self changes gather: [:e | e changes ])! !

!RBRefactoring methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/25/2012 20:03'!
whatToDisplayIn: aBrowser 
	
	^ self changes changes gather: [:e | e whatToDisplayIn: aBrowser ]! !

!RBAddClassChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 2/14/2012 20:11'!
nameToDisplay

	^ self changeString! !

!RBAddClassChange methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 2/14/2012 20:12'!
textToDisplay

	^ self definition! !

!RGMethodDefinition methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/24/2012 21:43'!
nameToDisplay

	^ self printString! !

!RBChildrenToSiblingsRefactoring methodsFor: '*NautilusRefactoring' stamp: 'BenjaminVanRyseghem 1/24/2012 21:18'!
whatToDisplayIn: aChangeBrowser

	^ aChangeBrowser changesOf: self! !

Object subclass: #Abstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusRefactoring-Tests'!

!Abstract methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/14/2012 19:38'!
plop

	self subclassResponsibility! !

Abstract subclass: #Foo
	instanceVariableNames: 'entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusRefactoring-Tests'!

Object subclass: #ChangesBrowser
	instanceVariableNames: 'changes selectedIndex newVersions window builtVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusRefactoring'!

!ChangesBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/20/2011 14:08'!
change: aChange

	^ self new
		changes: aChange;
		yourself! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/25/2012 20:15'!
accept

	self getChangesList do: [:change | change executeNotifying: []].
	newVersions associations do: [:assoc || oldMethod newSource |
		" recompile modified methods "
		oldMethod := assoc key.
		newSource := assoc value.
		oldMethod actualClass compile: newSource classified: oldMethod category ].
	window delete! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
acceptAction

	^ self accept! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
acceptLabel

	^ 'Accept'! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:22'!
acceptState

	^ false! !

!ChangesBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/20/2011 18:50'!
addAll: aWindow

	aWindow
		addMorph: self buildChangesList 
		frame: (0@0 corner: 1@0.5).
	aWindow
		addMorph: self buildDiffTextArea 
		frame: (0@0.5 corner: 1@0.9).
	aWindow
		addMorph: (self buildButtonsRow:  aWindow)  
		frame: (0@0.9 corner: 1@1).! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/20/2011 16:35'!
buildAcceptButton

	^ (PluggableButtonMorph 
			on: self
			getState: #acceptState
			action: #acceptAction
			label: #acceptLabel)
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			yourself! !

!ChangesBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/20/2011 18:54'!
buildButtonsRow: aWindow

	^ aWindow newRow: {
		self buildAcceptButton.
		self buildCancelButton}";
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		yourself"! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/20/2011 16:35'!
buildCancelButton

	^ (PluggableButtonMorph 
			on: self
			getState: #cancelState
			action: #cancelAction
			label: #cancelLabel)
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			yourself! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/24/2012 21:39'!
buildChangesList

	^ (PluggableListMorph
			on: self
			list: #getChangesList
			selected: #selectedIndex
			changeSelected: #selectedIndex:
			menu: nil
			keystroke: nil)
			wrapSelector: #wrapItem:;
			yourself! !

!ChangesBrowser methodsFor: 'text area behavior' stamp: 'BenjaminVanRyseghem 1/25/2012 19:53'!
buildDiffFrom: anItem

	| oldVersion newVersion |
	oldVersion := ''.
	newVersions 
		at: anItem
		ifPresent: [:string | ^ string].
		
	builtVersions at: anItem
		ifPresent: [:string | newVersion := string ]
		ifAbsent: [ 
			newVersion := self constructNewVersionOf: anItem index: (self selectedIndex).
			builtVersions at: anItem put: newVersion.] .
	
	^ TextDiffBuilder 
		buildDisplayPatchFrom: oldVersion to: newVersion.! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/20/2011 15:00'!
buildDiffTextArea

	^ PluggableTextMorph 
			on: self
			text: #getDiff
			accept: #setNewVersion:! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 18:54'!
cancel

	window delete! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
cancelAction

	^ self cancel! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:23'!
cancelLabel

	^ 'Cancel'! !

!ChangesBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 16:22'!
cancelState

	^ false! !

!ChangesBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/20/2011 14:08'!
changes

		^ changes! !

!ChangesBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/20/2011 14:08'!
changes: anObject
	
		changes := anObject! !

!ChangesBrowser methodsFor: 'dispatch' stamp: 'BenjaminVanRyseghem 1/24/2012 21:18'!
changesOf: aRefactoring

	self halt! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 18:56'!
compileNewSource: aString for: aMethodReference

	| aClass |
	aClass := aMethodReference actualClass.
	aClass compile: aString classified: aMethodReference category! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/25/2012 19:45'!
constructNewVersionOf: aMethodReference index: anInteger

	^ (self getChangesList at: (anInteger)) textToDisplay! !

!ChangesBrowser methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 1/25/2012 20:09'!
getChangesList

	^ self changes whatToDisplayIn: self.! !

!ChangesBrowser methodsFor: 'text area behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 15:02'!
getDiff

	| selectedItem |
	selectedItem := self getChangesList at: self selectedIndex ifAbsent: [ ^ '' ].
	^ self buildDiffFrom: selectedItem! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 16:29'!
initialize

	super initialize.
	newVersions := Dictionary new.
	builtVersions := Dictionary new! !

!ChangesBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/20/2011 18:51'!
openInWorld 

	window := StandardWindow new 
				"model: self;
				yourself".
	self addAll: window.
	window openInWorld.
	window title: self title.
	^ window! !

!ChangesBrowser methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 14:10'!
selectedIndex

	^ selectedIndex ifNil: [ selectedIndex := 0 ]! !

!ChangesBrowser methodsFor: 'list behavior' stamp: 'BenjaminVanRyseghem 5/20/2011 15:07'!
selectedIndex: anIndex

	selectedIndex := anIndex.
	self changed: #selectedIndex.
	self changed: #getDiff! !

!ChangesBrowser methodsFor: 'text area behavior' stamp: 'BenjaminVanRyseghem 5/23/2011 12:12'!
setNewVersion: aText
	
	| selectedItem |
	self changed: #clearUserEdits.
	selectedItem := self getChangesList at: self selectedIndex ifAbsent: [ ^ self ].
	newVersions at: selectedItem put: aText asString.! !

!ChangesBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2011 14:13'!
title

	^ 'Changes Browser'! !

!ChangesBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/25/2012 19:44'!
wrapItem: anItem

	^ anItem nameToDisplay! !

Object subclass: #NautilusRefactoring
	instanceVariableNames: 'model environment'
	classVariableNames: 'PromptOnRefactoring'
	poolDictionaries: ''
	category: 'NautilusRefactoring'!

!NautilusRefactoring class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/24/2012 19:23'!
model: model

	^ self new
		model: model;
		yourself! !

!NautilusRefactoring class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/20/2011 13:40'!
promptOnRefactoring

	^ PromptOnRefactoring ifNil: [ PromptOnRefactoring := true ]! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 1/24/2012 19:18'!
buildRenameRefactoringEngineFor: aClass

	| newName |
	newName := (UIManager default
			request: 'Enter the new class name:'
			initialAnswer: aClass name).
	newName isEmptyOrNil ifTrue: [ ^ nil ].
	^ RBRenameClassRefactoring
		model: RBNamespace new
		rename: aClass
		to: newName! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:23'!
categoryRegex
	
	self model sourceCode: self categoryRegexText! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:24'!
categoryRegexText

	^ 'ORCategoryRegexRefactoring new
	replace: ''^Kernel-(.*)$'' with: ''System-$1'' ignoreCase: false;
	yourself'! !

!NautilusRefactoring methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/24/2012 19:44'!
chooseMultipleFrom: anArray

	^ self chooseMultipleFrom: anArray title: ''! !

!NautilusRefactoring methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/24/2012 21:04'!
chooseMultipleFrom: anArray title: aString

	| window |
	window :=  TickDialogWindow 
					itemsList: anArray 
					itemsHeaderName: '' 
					title: aString
					defaultValue: true.

	^ anArray isEmpty
		ifTrue: [ anArray copyEmpty ]
		ifFalse: [ window chooseFromOwner: self model window ]! !

!NautilusRefactoring methodsFor: 'private-class' stamp: 'BenjaminVanRyseghem 2/14/2012 19:44'!
classObjectFor: anObject 

	(anObject isBehavior or: [anObject isTrait]) ifTrue: [ ^ environment classFor: anObject ].
	anObject isSymbol ifTrue: [ ^ environment classNamed: anObject ].
	^ anObject! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:24'!
classRegex

	self model sourceCode: self classRegexText! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:24'!
classRegexText

	^ 'ORClassRegexRefactoring new

	"Example 1: Change class prefixes"
	renameClasses;
	replace: ''^AB(.*)$'' with: ''CD$1'' ignoreCase: false;

	"Example 2: Generate empty test classes"
	createClasses;
	rootClass: TestCase;
	replace: ''^.*$'' with: ''$0Test'' ignoreCase: false;

	"Example 3: Copy classes"
	copyClasses;
	replace: ''^.*$'' with: ''$0Plus'' ignoreCase: false;

	yourself'! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 1/25/2012 19:09'!
generateAccessors

	| refactorings |
	refactorings := self privateGenerateAccessorsFor: self model selectedClass.
	refactorings ifNil: [ ^ self ].
	refactorings do: [:each | each model environment: self model browsedEnvironment ].
	self performRefactorings: refactorings! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 1/25/2012 18:05'!
generateSubclass

	| refactoring |
	refactoring := self privateGenerateSubclassFor: self model selectedClass.
	refactoring ifNil: [ ^ self ].
	refactoring model environment: self model browsedEnvironment.
	self performRefactoring: refactoring ! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/14/2012 19:30'!
generateSuperClass
	"Execute the refactoring of the receiver."

	| refactoring |
	refactoring := self privateGenerateSuperClassFor: self model selectedClass.
	refactoring ifNil: [ ^ self ].
	refactoring model environment: self model browsedEnvironment.
	self performRefactoring: refactoring.! !

!NautilusRefactoring methodsFor: 'display' stamp: 'BenjaminVanRyseghem 2/14/2012 21:08'!
handleError: anException
	anException actionBlock isNil
		ifTrue: [ self inform: anException messageText ]
		ifFalse: [ 
			(self confirm: anException messageText) 
				ifTrue: [ anException actionBlock value ] ].
	anException return! !

!NautilusRefactoring methodsFor: 'display' stamp: 'BenjaminVanRyseghem 2/14/2012 21:08'!
handleWarning: anException 
	| message |
	message := (anException messageText endsWith: '?')
		ifTrue: [ anException messageText ]
		ifFalse: [ anException messageText , String cr , 'Do you want to proceed?' ].
	(self confirm: message)
		ifTrue: [ anException resume ]
		ifFalse: [ anException return ]! !

!NautilusRefactoring methodsFor: 'performing' stamp: 'BenjaminVanRyseghem 2/14/2012 21:34'!
internalPerformRefactorings: aCollectionRefactoring
	"Try to properly label aRefactoring and perform it or open the changes browser, depending on the preferences of the user."

		self promptOnRefactoring
			ifFalse: [ aCollectionRefactoring do: [:e |
												self refactoringOptions: e.
												e execute ]]
			ifTrue: [
				| browser refactorings composite |
				composite := RBCompositeRefactoryChange new.
				aCollectionRefactoring do: [:e |
												self refactoringOptions: e.
												e primitiveExecute ].
				aCollectionRefactoring do: [:change | composite addChange: change ].
				
				composite changes ifEmpty: [ ^ self ].
		
				browser := ChangesBrowser change: composite.
				browser openInWorld ].! !

!NautilusRefactoring methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/24/2012 19:24'!
model
	
	^ model! !

!NautilusRefactoring methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/25/2012 19:00'!
model: aNautilusUI
	
	model := aNautilusUI.
	
	environment := (RBNamespace onEnvironment: aNautilusUI browsedEnvironment)
						name: self printString;
						yourself.! !

!NautilusRefactoring methodsFor: 'option' stamp: 'BenjaminVanRyseghem 2/14/2012 22:33'!
openEnvironment: anEnvironment for: aRefactoring
	
	anEnvironment isEmpty
		ifTrue: [ ^ self inform: 'Empty scope' ].
	
	Smalltalk tools browser fullOnEnvironment: anEnvironment! !

!NautilusRefactoring methodsFor: 'performing' stamp: 'BenjaminVanRyseghem 1/25/2012 19:04'!
performRefactoring: aRefactoring
	"Try to properly label aRefactoring and perform it or open the changes browser, depending on the preferences of the user."

	self performRefactorings: {aRefactoring}! !

!NautilusRefactoring methodsFor: 'performing' stamp: 'BenjaminVanRyseghem 2/14/2012 21:31'!
performRefactorings: aCollectionRefactoring

		[[ self internalPerformRefactorings: aCollectionRefactoring ]
			on: RBRefactoringWarning
			do: [ :exception | self handleWarning: exception ]]
			on: RBRefactoringError
			do: [ :exception | self handleError: exception ]! !

!NautilusRefactoring methodsFor: 'private-class' stamp: 'BenjaminVanRyseghem 1/25/2012 19:09'!
privateGenerateAccessorsFor: class

	^ class instVarNames collect: [:aVarName | 
				RBCreateAccessorsForVariableRefactoring
					model: environment
					variable: aVarName
					class: class
					classVariable: false ]! !

!NautilusRefactoring methodsFor: 'private-class' stamp: 'BenjaminVanRyseghem 1/25/2012 19:06'!
privateGenerateSubclassFor: class

	| subclassName |
	subclassName := self request: 'Enter new subclass name:'.
	
	^ RBAddClassRefactoring
		model: environment
		addClass: subclassName
		superclass: class
		subclasses: (self
			chooseMultipleFrom: class subclasses
			title: 'Select subclasses of ' , subclassName , ':')
		category: class category! !

!NautilusRefactoring methodsFor: 'private-class' stamp: 'BenjaminVanRyseghem 1/25/2012 19:06'!
privateGenerateSuperClassFor: class

	| superclassName subclasses |
	superclassName := self request: 'Enter new superclass name:'.
	superclassName isEmptyOrNil ifTrue: [ ^ self ].
	subclasses := self
						chooseMultipleFrom: class subclasses
						title: 'Select subclasses of ' , superclassName , ':'.
						
	subclasses ifNil: [ ^ self ].					
	
	^ RBChildrenToSiblingsRefactoring 
		model: environment
		name: superclassName
		class: class
		subclasses: subclasses! !

!NautilusRefactoring methodsFor: 'private-class' stamp: 'BenjaminVanRyseghem 2/14/2012 20:18'!
privateRealizeClassFor: aClass
	
	^ RBRealizeClassRefactoring model: environment className: aClass theNonMetaClass name! !

!NautilusRefactoring methodsFor: 'private-class' stamp: 'BenjaminVanRyseghem 2/14/2012 20:39'!
privateRemoveClassesFor: aCollection
	
	^ RBRemoveClassRefactoring 
			model: environment 
			classNames: (aCollection collect: [:e | e theNonMetaClass name ])! !

!NautilusRefactoring methodsFor: 'private-class' stamp: 'BenjaminVanRyseghem 2/14/2012 22:46'!
privateSplitClassFor: aClass
	| class |

	class := aClass theNonMetaClass.
	^ RBSplitClassRefactoring
		model: environment
		class: class
		instanceVariables: (self 
			chooseMultipleFrom: class instVarNames
			title: 'Select variables to extract:')
		newClassName: (self request: 'Enter new class name:')
		referenceVariableName: (self request: 'Enter new variable name where requests will be forwarded:')! !

!NautilusRefactoring methodsFor: 'option' stamp: 'BenjaminVanRyseghem 1/24/2012 19:19'!
promptOnRefactoring

	^ self class promptOnRefactoring! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:24'!
protocolRegex

	self model sourceCode: self protocolRegexText! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:25'!
protocolRegexText

	^ 'ORProtocolRegexRefactoring new
	replace: ''^\*system(.*)$'' with: ''*kernel$1'' ignoreCase: true;
	yourself'! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/14/2012 20:15'!
realizeClass

	| refactoring |
	refactoring := self privateRealizeClassFor: self model selectedClass.
	refactoring ifNil: [ ^ self ].
	refactoring model environment: self model browsedEnvironment.
	self performRefactoring: refactoring ! !

!NautilusRefactoring methodsFor: 'option' stamp: 'BenjaminVanRyseghem 2/14/2012 22:13'!
refactoringOptions: aRefactoring
	aRefactoring
		setOption: #implementorToInline
		toUse: [ :ref :imps | self requestImplementorToInline: imps ];
		setOption: #methodName
		toUse: [ :ref :name | self requestMethodNameFor: name ];
		setOption: #selfArgumentName
		toUse: [ :ref | self requestSelfArgumentName ];
		setOption: #selectVariableToMoveTo
		toUse: [ :ref :class :selector | self selectVariableToMoveMethodTo: selector class: class ];
		setOption: #variableTypes
		toUse: [ :ref :types :selected | self selectVariableTypesFrom: types selected: selected for: ref ];
		setOption: #extractAssignment
		toUse: [ :ref :string | self shouldExtractAssignmentTo: string ];
		setOption: #inlineExpression
		toUse: [ :ref :string | self shouldInlineExpression: string ];
		setOption: #alreadyDefined
		toUse: [ :ref :class :selector | self shouldOverride: selector in: class ];
		setOption: #useExistingMethod
		toUse: [ :ref :selector | self shouldUseExistingMethod: selector ];
		setOption: #openBrowser
		toUse: [ :ref :env | self openEnvironment: env  for: ref]! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/14/2012 21:31'!
removeClasses: aCollection
	"Execute the refactoring of the receiver."

	| refactoring |
	refactoring := self privateRemoveClassesFor: aCollection.
	refactoring ifNil: [ ^ self ].
	refactoring model environment: self model browsedEnvironment.

	self performRefactoring: refactoring.
	^ true! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/14/2012 22:14'!
renameClass: aClass
	
	aClass
		ifNotNil: [
			| refactoring | 
			refactoring := self buildRenameRefactoringEngineFor: aClass.
			refactoring ifNil: [ ^ self ].
			refactoring model environment: self model browsedEnvironment.
			self performRefactoring: refactoring ]! !

!NautilusRefactoring methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/24/2012 21:03'!
request: aString

	^ UIManager default request: aString initialAnswer: ''! !

!NautilusRefactoring methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/24/2012 20:54'!
request: aString initialAnswer: aTemplateString

	^ UIManager default request: aString initialAnswer: aTemplateString
! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:25'!
rewriteCode
	
	self model sourceCode: self rewriteCodeText! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:25'!
rewriteCodeText
	
	^ 'RBParseTreeRewriter new
	replace: ''`@object'' with: ''`@object'';
	replace: ''`@object'' with: ''`@object'' when: [ :node | true ];
	replace: ''`@object'' withValueFrom: [ :node | node ];
	replace: ''`@object'' withValueFrom: [ :node | node ] when: [ :node | true ];
	replaceMethod: ''`@method: `@args | `@temps | `@.statements'' with: ''`@method: `@args | `@temps | `@.statements'';
	replaceMethod: ''`@method: `@args | `@temps | `@.statements'' with: ''`@method: `@args | `@temps | `@.statements'' when: [ :node | true ];
	replaceMethod: ''`@method: `@args | `@temps | `@.statements'' withValueFrom: [ :node | node ];
	replaceMethod: ''`@method: `@args | `@temps | `@.statements'' withValueFrom: [ :node | node ] when: [ :node | true ];
	yourself'! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:25'!
searchCode
	
	self model sourceCode: self searchCodeText! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:25'!
searchCodeText

	^ 'RBParseTreeSearcher new
	matches: ''`@object'' do: [ :node :answer | node ];
	matchesMethod: ''`@method: `@args | `@temps | `@.statements'' do: [ :node :answer | node ];
	yourself'! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:25'!
sourceRegex
	
	self model sourceCode: self sourceRegexText! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:25'!
sourceRegexText

	^ 'ORSourceRegexRefactoring new
	
	"Example 1: Replace symbols with strings"
	replace: ''#(\w+)'' with: ''''''$1'''''' ignoreCase: false;
	
	"Example 2: Replace 4 spaces with tabs"
	replace: ''    '' with: ''	'' ignoreCase: false;

	yourself'! !

!NautilusRefactoring methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/14/2012 22:43'!
splitClass: aClass
	
	aClass
		ifNotNil: [
			| refactoring | 
			refactoring := self privateSplitClassFor: aClass.
			refactoring ifNil: [ ^ self ].
			refactoring model environment: self model browsedEnvironment.
			self performRefactoring: refactoring ]! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:26'!
typeClass
	
	self model sourceCode: (self typeClassTextFor: self selectedClasses)! !

!NautilusRefactoring methodsFor: 'rewrite code' stamp: 'BenjaminVanRyseghem 1/24/2012 19:26'!
typeClassTextFor: aCollectionOfClass

	^ String streamContents: [:s |
		aCollectionOfClass do: [:class |
			s << (RBRefactoryTyper new runOn: class) printString.
			s cr; cr ]]! !

Object subclass: #Poulpe
	instanceVariableNames: 'i1 i2 i3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusRefactoring-Tests'!

!Poulpe methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/14/2012 23:49'!
i1
	^ i1! !

!Poulpe methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/14/2012 23:49'!
i1: anObject
	i1 := anObject! !

!Poulpe methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/14/2012 23:49'!
i2
	^ i2! !

!Poulpe methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/14/2012 23:49'!
i2: anObject
	i2 := anObject! !

!Poulpe methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/14/2012 23:49'!
i3
	^ i3! !

!Poulpe methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/14/2012 23:49'!
i3: anObject
	i3 := anObject! !

ComposableModel subclass: #CodeCriticBrowser
	instanceVariableNames: 'environment listModel1 listModel2 listModel3 process status textModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusRefactoring'!

!CodeCriticBrowser commentStamp: '<historical>' prior: 0!
A CodeCriticBrowser is a UI made to browse code critics refactor!

!CodeCriticBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/23/2012 19:21'!
internSpec

	^ { #PanelMorph.
			#changeTableLayout.
			#listDirection:.		#bottomToTop.
			#addMorph:. 		self topSpec.
			#hResizing:. 		#spaceFill.
			#vResizing:. 		#spaceFill.
			#addMorph:. 		{	#model.	#textModel.	#internSpec.	}}! !

!CodeCriticBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/23/2012 19:22'!
title

	^ 'Code critics'! !

!CodeCriticBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/23/2012 20:02'!
topSpec

	^ { #PanelMorph.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#hResizing:. 		#spaceFill.
			#vResizing:. 		#spaceFill.
			#addMorph:. 		{	#model.	#listModel1.	#internSpec.	}.
			#addMorph:. 		{	#model.	#listModel2.	#internSpec.	}.
			#addMorph:. 		{	#model.	#listModel3.	#internSpec.	}}! !

!CodeCriticBrowser methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 1/24/2012 03:00'!
basicSearch: aRule
	| numberSelectors precentIncrement percent checker |
	aRule resetResult.
	self status: 'Searching'; refresh.
	numberSelectors := self environment numberSelectors.
	precentIncrement := numberSelectors isZero
		ifFalse: [ 100.0 / numberSelectors ]
		ifTrue: [ 100.0 ].
	percent := 0.0.
	checker := (Smalltalk at: #SmalllintChecker) new.
	checker
		rule: aRule;
		context: (Smalltalk at: #SmalllintChecker) new;
		environment: self environment;
		methodBlock: [ 
			percent := percent + precentIncrement min: 100.
			self status: percent truncated asString , '%' ].
	[ checker run ] ensure: [
		self refresh.
		self status: (self root problemCount > 0
			ifTrue: [ self root problemCount asString , ' problems' ]).
		checker release.
		process := nil ]! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
environment
	
	^ environment! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
environment: anObject
	
	environment := anObject! !

!CodeCriticBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
initialize
	"Initialization code for CodeCriticBrowser"

	super initialize.

	listModel1 := self instantiate: ListComposableModel.
	listModel2 := self instantiate: ListComposableModel.
	listModel3 := self instantiate: ListComposableModel.
	textModel := self instantiate: TextModel.
	
	listModel1 wrappingBlock: [:rule | rule name ].
	listModel2 wrappingBlock: [:rule | rule name ].
	listModel3 wrappingBlock: [:rule | rule name ].
	
	listModel1 whenSelectedItemChanges: [:selection |
		listModel2 resetSelection.
		listModel2 items: (selection 
								ifNil: [ {} ]
								ifNotNil: [ selection rules ])].
	
	listModel2 whenSelectedItemChanges: [:selection |
		listModel3 resetSelection.
		listModel3 items: (selection 
								ifNil: [ {} ]
								ifNotNil: [ selection rules ])].
	
	listModel3 whenSelectedItemChanges: [:selection |
		selection 
			ifNil: [ textModel text: '' ]
			ifNotNil: [ textModel text: selection result label ]]! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
listModel1
	
	^ listModel1! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
listModel1: anObject
	
	listModel1 := anObject! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
listModel2
	
	^ listModel2! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
listModel2: anObject

	listModel2 := anObject! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
listModel3
	
	^ listModel3! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
listModel3: anObject
	
	listModel3 := anObject! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
process
	
	^ process! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
process: anObject
	
	process := anObject! !

!CodeCriticBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
rules: aCollection

	listModel1 items: aCollection! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
status
	
	^ status! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
status: anObject
	
	status := anObject! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
textModel
	
	^ textModel! !

!CodeCriticBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:55'!
textModel: anObject
	
	textModel := anObject! !
